<script setup lang="ts">
import AnswerButton from './AnswerButton.vue';
import type { Answers } from '@/types/Answers';
import AnswerButtonDrawer from './AnswerButtonDrawer.vue';
import { computed } from 'vue';
import { ForwardSlots } from 'vue-forward-slots';

const props = withDefaults(
  defineProps<{
    answers: Answers;
    hasDrawer?: boolean;
  }>(),
  { hasDrawer: false }
);

const emit = defineEmits(['onAnswerClick']);

const classes = computed(() => {
  if (props.answers.answers.length === 1) {
    return 'grid-cols-1';
  }
  if (props.answers.answers.length === 2) {
    return 'grid-cols-1 @sm:grid-cols-2 ';
  }
  return 'grid-cols-1 @sm:grid-cols-2 @3xl:grid-cols-4';
});

function onAnswerClick(answer: any) {
  emit('onAnswerClick', answer);
}
</script>

<template>
  <div class="@container">
    <div :class="classes" class="grid gap-4">
      <div v-for="answer in answers.answers" :key="answer.buttonText">
        <AnswerButton class="w-full max-w-96" :answer="answer" @onAnswerClick="onAnswerClick"> </AnswerButton>
        <div class="mt-2" v-if="hasDrawer">
          <ForwardSlots :slots="$slots">
            <AnswerButtonDrawer :answer="answer" />
          </ForwardSlots>
        </div>
      </div>
    </div>
  </div>
</template>
